/*
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Copyright (c) 2012 digitalSTROM.org, Zurich, Switzerland
 *  Author: Roman Khler <roman.koehler@aizo.com>
 */


var fLoading=false;
var oTimedEvent;

function changeListener() {
    var sValue=dss.ajaxSyncRequest('/json/property/getString',{path:'/usr/states/holiday/value'});
    var oValue=JSON.parse(sValue);
    if (oValue!=null)
        if (oValue.result!=null)
            if (oValue.result.value!=null) {
                if (oValue.result.value=='on')
                    return _("Simulation is <b>active</b>") + "<br><br>";
                else
                    return _("Simulation is <b>not active</b>") + "<br><br>";
            }
    return "Simulationstate is currently not known, please wait" + "<br><br>";
}

function modeChange(newValue) {
    if (fLoading)
        return;
    dss.raiseEvent('presence-simulator', {
        actions : 'setMode',
        value : newValue
    })
}

function emailChange(fEnabled,txtReceiver) {
    if (fLoading)
        return;
    dss.raiseEvent('presence-simulator', {
        actions : 'setEmail',
        enabled : (fEnabled?1:0),
        receiver : txtReceiver
    })
}

Ext.define(
                'DSS.addon.PresenceSimulator',
                {

                    extend : 'DSS.addon.Framework',

                    config : {
                        appName : 'Presence Simulator',
                        appId : 'presence-simulator',
                        appVersion : '1.1.0',
                        appIcon : 'images/app_icon.png'
                    },

                    getHelp : function() {
                        return Ext.create('Ext.Component', {
                            loader : {
                                url : 'locale/' + dss.staticDataModel.activeLanguage + '/help.html',
                                autoLoad : true,
                                disableCaching : false
                            }
                        });
                    },
                    makeAutoModePanel : function () {
                        this.autoMode=Ext.create('Ext.form.RadioGroup',{
                            fieldLabel:_('When should the simulation be active?'),
                            items:[
                                   {   inputValue:0,
                                       boxLabel:_('always off - holiday times and absent state will not be used'),
                                       name:'autoMode'},
                                   {   inputValue:1,
                                       boxLabel:_('only on holidays'),
                                       name:'autoMode'},
                                   {   inputValue:2,
                                       boxLabel:_('on holidays and when absend'),
                                       name:'autoMode'},
                                   {   inputValue:3,
                                       boxLabel:_('always on'),
                                       name:'autoMode'},
                                   ],
                            columns:1,
                            labelAlign:'top',
                            style: {color:"#005138"}
                        });
                        this.autoMode.addListener('change',function(oThis,newValue,oldValue,eOpts) {
                            if (typeof(newValue.autoMode)=='number')
                                modeChange(newValue.autoMode);   
                        });
                        return this.autoMode;
                    },
                    makeStatePanel : function () {
                        var oReturn = Ext.create('Ext.form.Panel', {
                            border : 0,
                            html:'<div id="subPanel_AutoQuery" style="color:#005138;">' + changeListener() + '</div>',
                            style: {color:"#005138"}
                        });
                        
                        var oFunct=function()
                        {                       
                            if (document.getElementById("subPanel_AutoQuery")!=null){                 
                                document.getElementById("subPanel_AutoQuery").innerHTML=changeListener();
                            }
                        }                        
                        window.setInterval(oFunct,5*1000);
                        return oReturn;
                    },
                    makeEmailPanel : function () {
                        var me=this;
                        var description = Ext.create('Ext.form.Panel', {
                            border : 0,
                            html:'<span style="color:#005138;">' + _('Should be send a Email on turning on or off the simulation ?')+ '</span>',
                            style: {color:"#005138"},
                            colspan:3
                        });
                        
                        var oNo= Ext.create('Ext.form.field.Radio',{
                            name : 'edit_emailReceiver_email_enabler',
                            inputValue : 0,
                            boxLabel: _('no'),
                            colspan:3,
                            style: {color:"#005138"}
                        });
                        this.emailEnabler= Ext.create('Ext.form.field.Radio',{
                            name : 'edit_emailReceiver_email_enabler',
                            inputValue : 1,
                            boxLabel: _('yes'),
                            width:100,
                            style: {color:"#005138"}    
                        });
                        
                        
                        this.emailAdress = Ext.create('Ext.form.field.Text', {
                            name : 'edit_emailReceiver_email_email',
                            id : 'edit_emailReceiver_email_email',
                            fieldLabel : _('Receiver'),
                            allowBlank : false,
                            regex : /\b[A-Z0-9._%-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i,
                            regexText : _('The emailadress has the wrong format'),
                            style: {color:"#005138"},
                            width:400,
                            labelWidth:65
                        });
                            
                        var yesPanel = Ext.create('Ext.Panel', {
                            border : 0,
                            width : 600,
                            layout: {
                                type: 'hbox',
                                align: 'center'
                            },
                            items:[this.emailEnabler,this.emailAdress ]
                        });

                        var oButton=Ext.create('Ext.button.Button',{
                            text:_('apply'),
                            handler:function() {emailChange(me.emailEnabler.getValue(),me.emailAdress.getValue());}
                        });
                        yesPanel.add(oButton);                  

                        this.emailEnabler.addListener('change',function(oThis,newValue,oldValue,eOpts) {
                            if (newValue) {
                                oButton.enable();
                                me.emailAdress.enable();
                            } else {
                                oButton.disable();
                                me.emailAdress.disable();
                            } 
                            emailChange(me.emailEnabler.getValue(),me.emailAdress.getValue());
                        });
                        oNo.addListener('change',function(oThis,newValue,oldValue,eOpts) {
                            if (!newValue) {
                                oButton.enable();
                                me.emailAdress.enable();
                            } else {
                                oButton.disable();
                                me.emailAdress.disable();
                            }                                
                        });
                                                                
                        return Ext.create('Ext.Panel', {
                            layout: {
                                type: 'vbox'
                            },
                            border : 0,
                            height: 70,
                            width: 700,
                            items:[description,
                                   oNo,
                                   yesPanel]
                        });
                        
                    },
                    autoMode:null,
                    emailEnabler:null,
                    emailAdress:null,
                    getContent : function() {

                        var me = this;

                        var oConfigHoliday = {
                            defaultSortCol : 'name',
                            border: false,
                            storeConfig : {
                                storeId : 'holidayStore',
                                fields : [ {
                                    name : 'id'
                                }, {
                                    name : 'name',
                                    sortType : 'asUCText'
                                }, {
                                    name : 'von',
                                    sortType : 'asUCText'
                                }, {
                                    name : 'bis',
                                    sortType : 'asUCText'
                                } ]
                            },
                            columns : [ {
                                header : _('Name'),
                                dataIndex : 'name',
                                xtype : 'textcolumn',
                                flex : 1
                            }, {
                                header : _('from'),
                                dataIndex : 'von',
                                xtype : 'datecolumn',
                                width : 200
                            }, {
                                header : _('until'),
                                dataIndex : 'bis',
                                xtype : 'datecolumn',
                                width : 200
                            } ],
                            buttonText : {
                                newButton : _('New holiday'),
                                editButton : _('Edit holiday'),
                                deleteButton : _('Delete holiday')
                            },
                            editorConfig : {
                                title : _('Action'),
                                staticControls : [ {
                                    type : 'text',
                                    label : _('Name'),
                                    id : 'name'
                                }, {
                                    type : 'hidden',
                                    label : 'id',
                                    id : 'id'
                                }, {
                                    type : 'date',
                                    label : _('from'),
                                    id : 'von'
                                }, {
                                    type : 'date',
                                    label : _('until'),
                                    id : 'bis'
                                } ]
                            },
                            listeners : {
                                'loadDataStore' : function(grid) {
                                    me.loadHolidayParameter(grid);
                                },
                                'saveEntry' : function(grid, values) {
                                    dss.raiseEvent('presence-simulator.holiday-config', {
                                        actions : 'save',
                                        value : Ext.JSON.encode(values)
                                    })
                                    me.waitAndReloadHoliday(grid);
                                },
                                'deleteEntry' : function(grid, entry) {
                                    dss.raiseEvent('presence-simulator.holiday-config', {
                                        actions : 'delete',
                                        id : entry.get('id')
                                    })
                                    me.waitAndReloadHoliday(grid);
                                }
                            }
                        };
                        var oConfigActivity = {
                            defaultSortCol : 'name',
                            disabledProperty : 'disabled',
                            border: false,
                            storeConfig : {
                                storeId : 'actionStore',
                                fields : [ {
                                    name : 'id'
                                }, {
                                    name : 'disabled',
                                    sortType : 'asBoolean'
                                }, {
                                    name : 'name',
                                    sortType : 'asUCText'
                                }, {
                                    name : 'actions',
                                    sortType : 'asAction'
                                }, {
                                    name : 'time',
                                    sortType : 'asTime'
                                }, {
                                    name : 'recurrence',
                                    sortType : 'asRecurrence'
                                } ]
                            },
                            columns : [ {
                                header : _('Active'),
                                dataIndex : 'disabled',
                                resizable : false,
                                xtype : 'disabledcolumn',
                                width : 50
                            }, {
                                header : _('Name'),
                                dataIndex : 'name',
                                xtype : 'textcolumn',
                                width : 200
                            }, {
                                header : _('Action'),
                                dataIndex : 'actions',
                                maintainFlex : true,
                                flex : 5,
                                xtype : 'actioncolumn'
                            }, {
                                header : _('Time'),
                                dataIndex : 'time',
                                xtype : 'timecolumn',
                                width : 200,
                                customColumnRenderer : function (val, metadata, record, rowIdx, colIdx, store, view) {
                                    var fOverride=false;
                                    var pad = function(i) { return (i < 10 ? '0'+i : i); };

                                    var sText=  pad(Math.floor(Math.abs(val.offset/3600))) + ":" +
                                    pad(Math.floor(Math.abs(val.offset/60)%60));

                                    switch (val.timeBase)
                                    {
                                        case 'beforeHoliday':
                                            fOverride=true;
                                            if (val.offset==0)
                                                sText = _('at simulation start');
                                            else if (val.offset<0)
                                                sText = Ext.String.format2(_("{time} before simulation starts"),{time:sText});
                                            else
                                                sText = Ext.String.format2(_("{time} after simulation starts"),{time:sText});
                                        break;
                                        case 'afterHoliday':
                                            fOverride=true;
                                            if (val.offset==0)
                                                sText = _('at simulation end');
                                            else if (val.offset<0)
                                                sText = Ext.String.format2(_("{time} before simulation ends"),{time:sText});
                                            else
                                                sText = Ext.String.format2(_("{time} after simulation ends"),{time:sText});
                                        break;
                                    }
                                    if (!fOverride)
                                        return null;
                                    if (val.limitBefore!=null)  {
                                        sText+=Ext.String.format2(_("<br>but not past {hour}:{minute} o'clock",{hour:pad(Math.floor(Math.abs(val.limitBefore/3600))),minute:pad(Math.floor(Math.abs(val.limitBefore/60)%60))}));
                                    }
                                    if (val.limitAfter!=null)  {
                                        sText+=Ext.String.format2(_("<br>but not before {hour}:{minute} o'clock",{hour:pad(Math.floor(Math.abs(val.limitBefore/3600))),minute:pad(Math.floor(Math.abs(val.limitBefore/60)%60))}));
                                    }
                                    if (val.random!=null) {
                                        sText="&plusmn;" + sText;
                                    } 
                                        
                                    return sText;
                                }                               
                            }, {
                                header : _('Recurrence'),
                                dataIndex : 'recurrence',
                                xtype : 'recurrencecolumn',
                                width : 160
                            } ],
                            buttonText : {
                                newButton : _('New event'),
                                editButton : _('Edit event'),
                                enableButton : _('Enable event'),
                                disableButton : _('Disable event'),
                                testButton : _('Test event'),
                                deleteButton : _('Delete event')
                            },
                            editorConfig : {
                                title : _('Action'),
                                staticControls : [ {
                                    type : 'text',
                                    label : _('Name'),
                                    id : 'name'
                                }, {
                                    type : 'hidden',
                                    label : 'id',
                                    id : 'id'
                                } ],
                                tabControls : [
                                        {
                                            tabLabel : _('time of execution'),
                                            tabDescription : _('Choose the time, when the activities should be executed.'),
                                            content : [ {
                                                label : _('Time'),
                                                type : 'timeReference',
                                                id : 'time',
                                                randomize: 1800,
                                                additionalAbsoluteValues:[{id:'beforeHoliday',label:_('when simulation starts')},
                                                                          {id:'afterHoliday',label:_('when simulation ends')}],
                                                referenceChangeListener:function (editor,control,selectedItem) {
                                                    if (selectedItem=='beforeHoliday')
                                                        editor.enableControl('recurrence',false);
                                                    else if (selectedItem=='afterHoliday')
                                                        editor.enableControl('recurrence',false);
                                                    else
                                                        editor.enableControl('recurrence',true);
                                                        
                                                }
                                            }, {
                                                type : 'weekdaySelection',
                                                id : 'recurrence',
                                                label : _('Recurrence'),
                                                flex : true
                                            } ]
                                        },
                                        {
                                            tabLabel : _('Activity'),
                                            tabDescription : _('Choose the activities, which should be executed.'),
                                            content : [ {
                                                type : 'ActionConfigurator',
                                                id : 'actions',
                                                flex : true,
                                                withDelay : true
                                            } ]
                                        } ]
                            },
                            listeners : {
                                'loadDataStore' : function(grid) {
                                    me.loadActionParameter(grid);
                                },
                                'saveEntry' : function(grid, values) {
                                    dss.raiseEvent('presence-simulator.te-config', {
                                        actions : 'save',
                                        value : Ext.JSON.encode(values)
                                    })
                                    me.waitAndReloadTE(grid);
                                },
                                'enableEntry' : function(grid, entry) {
                                    dss.raiseEvent('system-addon-timed-events.config', {
                                        actions : 'enable',
                                        id : entry.get('id')
                                    });
                                    me.waitAndReloadTE(grid);
                                },
                                'disableEntry' : function(grid, entry) {
                                    dss.raiseEvent('system-addon-timed-events.config', {
                                        actions : 'disable',
                                        id : entry.get('id')
                                    })
                                    me.waitAndReloadTE(grid);
                                },
                                'deleteEntry' : function(grid, entry) {
                                    dss.raiseEvent('presence-simulator.te-config', {
                                        actions : 'delete',
                                        id : entry.get('id')
                                    })
                                    me.waitAndReloadTE(grid);
                                },
                                'testEntry' : function(grid, entry) {
                                    dss.ajaxAssyncRequestWithoutAnswer("/json/event/raise", {
                                        name : 'action_execute',
                                        parameter : "path=/scripts/system-addon-timed-events/entries/" + entry.get('id')
                                    });
                                }
                            }
                        };
                        
                        var statePanel=this.makeStatePanel();                        
                        var autoModePanel=this.makeAutoModePanel();
                        var emailPanel=this.makeEmailPanel();
                        
                        var oGeneralPanel = Ext.create(
                                        'Ext.panel.Panel',
                                        {
                                            title : _('general'),
                                            style: {padding:'10px'},
                                            items : [
                                                    {
                                                        xtype : 'fieldset',
                                                        style: {padding:'10px'},
                                                        title : _('Settings'),
                                                        items:[statePanel,autoModePanel,emailPanel]
                                                    },
                                                    {
                                                        xtype : 'fieldset',
                                                        title : _('Hints'),
                                                        style: {padding:'10px',
                                                            color:"#005138"},
                                                        items : [ {
                                                            xtype : 'panel',
                                                            border : 0,
                                                            style: {color:"#005138"},
                                                            html : dss.ajaxSyncRequest('locale/' + dss.staticDataModel.activeLanguage + '/hint.html',{})
                                                        } ]
                                                    } ]
                                        });

                        var oHolidayPanel = Ext.create('DSS.gridPanel', oConfigHoliday);
                        var oActivityPanel = Ext.create('DSS.gridPanel', oConfigActivity);
                        return Ext.create('Ext.tab.Panel', {
                            layout : 'fit',
                            items : [ oGeneralPanel, 
                                      Ext.create('Ext.panel.Panel', { title : _('holiday'), layout : 'fit', items : [ oHolidayPanel ] }) ,
                                      Ext.create('Ext.panel.Panel', {
                                layout : 'fit',
                                title : _('activity'),
                                items : [ oActivityPanel ]
                            }) ]
                        });
                    },
                    waitAndReloadTE : function(grid) {
                        var me = this;
                        var iSubscriptID = Math.floor(Math.random() * 100000000000);
                        dss.ajaxSyncRequest('/json/event/subscribe', {
                            subscriptionID : iSubscriptID,
                            name : 'system-addon-timed-events.saved'
                        });
                        dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
                            subscriptionID : iSubscriptID,
                            timeout : 60 * 1000
                        }, function() {
                            me.loadActionParameter(grid);
                            dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
                                subscriptionID : iSubscriptID,
                                name : 'system-addon-timed-events.saved'
                            });
                        });
                    },
                    waitAndReloadHoliday : function(grid) {
                        var me = this;
                        var iSubscriptID = Math.floor(Math.random() * 100000000000);
                        dss.ajaxSyncRequest('/json/event/subscribe', {
                            subscriptionID : iSubscriptID,
                            name : 'presence-simulator.saved'
                        });
                        dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
                            subscriptionID : iSubscriptID,
                            timeout : 60 * 1000
                        }, function() {
                            me.loadHolidayParameter(grid);
                            dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
                                subscriptionID : iSubscriptID,
                                name : 'presence-simulator.saved'
                            });
                        });
                    },
                    loadGeneralParameter : function () {
                        fLoading=true;
                        var sString = dss.ajaxSyncRequest('/json/property/query', {
                            'query' : '/scripts/presence-simulator/general(*)'
                        });
                        var oResult=JSON.parse(sString);
                        if (oResult.result!=null)
                            if (oResult.result.general!=null)
                                if (oResult.result.general[0]!=null) {
                                    if (oResult.result.general[0].autoMode!=null)
                                        this.autoMode.setValue({autoMode:oResult.result.general[0].autoMode});
                                    if (oResult.result.general[0].emailMode!=null) {
                                        if (oResult.result.general[0].emailMode!=1)
                                            this.autoMode.setValue({edit_emailReceiver_email_enabler:0});
                                        else
                                            this.autoMode.setValue({edit_emailReceiver_email_enabler:1});
                                    }                                        
                                    if (oResult.result.general[0].emailReceiver!=null)
                                        this.emailAdress.setValue(oResult.result.general[0].emailReceiver)
                                }                        
                        fLoading=false;
                    },
                    loadActionParameter : function(grid) {
                        var sString = dss.ajaxSyncRequest('/json/property/query', {
                            'query' : '/scripts/system-addon-timed-events/entries/*(*)/*(*)/*(*)'
                        });
                        var result = Ext.JSON.decode(sString);
                        oTimedEvent=dss.parsePropertyQueryAnswer(result,[{name:'name',type:'simple'},
                                                                             {name:'id',type:'simple'},
                                                                             {name:'random',type:'simple'},
                                                                             {name:'disabled',type:'condition/enabled'},
                                                                             {name:'holiday',type:'condition/state'}, // state holiday .... must be "active"
                                                                             {name:'actions',type:'action'},
                                                                             {name:'time',type:'time'},                        
                                                                             {name:'recurrence',type:'recurrence'}]);
                        
                        if (oTimedEvent!=null) {
                            var oResultObject=[];
                            for (var iIndex=0;iIndex<oTimedEvent.length;iIndex++){ 
                                if (oTimedEvent[iIndex].random!=null)
                                    oTimedEvent[iIndex].randomEnabled=true;
                                else
                                    oTimedEvent[iIndex].randomEnabled=false;
                                if (oTimedEvent[iIndex]['holiday']!=null)
                                    if (oTimedEvent[iIndex]['holiday']=='on') 
                                        oResultObject.push(oTimedEvent[iIndex]);
                            }
                            grid.loadParameter(oResultObject);
                        }
                        this.loadGeneralParameter();
                    },
                    loadHolidayParameter : function(grid) {
                        var sString = dss.ajaxSyncRequest('/json/property/query', {
                            'query' : '/scripts/presence-simulator/values/holiday/*(*)'
                        });
                        var result = Ext.JSON.decode(sString);
                        var oResultObject = dss.parsePropertyQueryAnswer(result, [ {
                            name : 'name',
                            type : 'simple'
                        }, {
                            name : 'id',
                            type : 'simple'
                        }, {
                            name : 'von',
                            type : 'date'
                        }, {
                            name : 'bis',
                            type : 'date'
                        } ]);
                        if (oResultObject != null) {
                            grid.loadParameter(oResultObject);
                        }
                        this.loadGeneralParameter();
                    }
                });

Ext.onReady(function() {
    dss.buildUpLang(['locale/{languageSuffix}/presence-simulator.po']);
    var presencesim = Ext.create('DSS.addon.PresenceSimulator');
    presencesim.initPage();
});
